## XklEngine XklEngine |

## Functions

GType | xkl_engine_features_get_type ()
GType | xkl_engine_listen_modes_get_type ()
GType | xkl_engine_state_change_get_type ()

## Properties

gchar * | backendName | Read
guint | default-group | Read
gpointer | display | Read / Write / Construct Only
XklEngineFeatures | features | Read
gboolean | indicators-handling | Read
guint | max-num-groups | Read
guint | num-groups | Read
guint | secondary-groups-mask | Read

## Signals

void | X-config-changed | Run Last
void | X-new-device | Run Last
void | X-state-changed | Run Last
gint | new-toplevel-window | Run Last

## Types and Values

| XklEnginePrivate
enum | XklEngineStateChange
enum | XklEngineFeatures
| XklState
| XklEngine

## Object Hierarchy

        GObject
        ╰── XklEngine

## Description

## Functions

### xkl_engine_features_get_type ()

    GType
    xkl_engine_features_get_type (void);

### xkl_engine_listen_modes_get_type ()

    GType
    xkl_engine_listen_modes_get_type (void);

### xkl_engine_state_change_get_type ()

    GType
    xkl_engine_state_change_get_type (void);

## Types and Values

### XklEnginePrivate

    typedef struct _XklEnginePrivate XklEnginePrivate;

### enum XklEngineStateChange

The type of the keyboard state change

#### Members

GROUP_CHANGED | Group was changed |
INDICATORS_CHANGED | Indicators were changed |

### enum XklEngineFeatures

A set of flags used to indicate the capabilities of the active backend

#### Members

XKLF_CAN_TOGGLE_INDICATORS | Backend allows to toggls indicators on/off |
XKLF_CAN_OUTPUT_CONFIG_AS_ASCII | Backend allows writing ASCII representation of the configuration |
XKLF_CAN_OUTPUT_CONFIG_AS_BINARY | Backend allows writing binary representation of the configuration |
XKLF_MULTIPLE_LAYOUTS_SUPPORTED | Backend supports multiple layouts |
XKLF_REQUIRES_MANUAL_LAYOUT_MANAGEMENT | Backend requires manual configuration, some daemon should do xkl_start_listen(engine,XKLL_MANAGE_LAYOUTS); |
XKLF_DEVICE_DISCOVERY | Backend supports device discovery, can notify |

### XklState

    typedef struct _XklState XklState;

### XklEngine

    typedef struct _XklEngine XklEngine;

## Property Details

### The `“backendName”` property

      “backendName”              gchar *

Backend name.

Flags: Read

Default value: NULL

### The `“default-group”` property

      “default-group”            guint

Default group.

Flags: Read

Allowed values: <= 256

Default value: 0

### The `“display”` property

      “display”                  gpointer

X Display pointer.

Flags: Read / Write / Construct Only

### The `“features”` property

      “features”                 XklEngineFeatures

Backend features.

Flags: Read

### The `“indicators-handling”` property

      “indicators-handling”      gboolean

Whether engine should handle indicators.

Flags: Read

Default value: FALSE

### The `“max-num-groups”` property

      “max-num-groups”           guint

Max number of groups.

Flags: Read

Allowed values: <= 256

Default value: 0

### The `“num-groups”` property

      “num-groups”               guint

Current number of groups.

Flags: Read

Allowed values: <= 256

Default value: 0

### The `“secondary-groups-mask”` property

      “secondary-groups-mask”    guint

Secondary groups mask.

Flags: Read

Allowed values: <= 256

Default value: 0

## Signal Details

### The `“X-config-changed”` signal

    void
    user_function (XklEngine *xklengine,
                   gpointer   user_data)

Flags: Run Last

### The `“X-new-device”` signal

    void
    user_function (XklEngine *xklengine,
                   gpointer   user_data)

Flags: Run Last

### The `“X-state-changed”` signal

    void
    user_function (XklEngine           *xklengine,
                   XklEngineStateChange arg1,
                   gint                 arg2,
                   gboolean             arg3,
                   gpointer             user_data)

Flags: Run Last

### The `“new-toplevel-window”` signal

    gint
    user_function (XklEngine *xklengine,
                   glong      arg1,
                   glong      arg2,
                   gpointer   user_data)

Flags: Run Last